import java.util.*;

/**
 * A1
 * Schreiben bzw. vervollständigen Sie bitte gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
 * Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile.
 * Neben den Testfällen in 'main' müssen auch alle Zusicherungen in den Kommentaren und Bedingungen
 * auf dem Aufgabenblatt gelten.
 */

public class PraxisAufgabe {

    /*
    Aufgabe: siehe Angabeblatt

        Ergänzen Sie bitte fehlende Teile der Klassen
        an den mit TODO gekennzeichneten Stellen.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.

    */

    // 'main' enthält vorgefertigte Testfälle jeweils mit Sollausgabe als Kommentar.
    // Ergänzen weiterer Testfälle ist hier erlaubt.
    // Das Testen wird nicht beurteilt.
    public static void main(String[] args) {
        Interval i1 = new NonEmpty(-1, 10);
        Interval i2 = new NonEmpty(5, 20);
        Interval i3 = new NonEmpty(20, 25);

        try {
            i3 = new NonEmpty(20, -25);
        } catch (IllegalArgumentException e) {
            System.out.println(e.getMessage()); // lower (20) must not be greater than upper (-25)!
        }

        System.out.println(i1.intersect(i2)); //[5, 10]
        System.out.println(i2.intersect(i3)); //[20, 20]
        System.out.println(i1.intersect(i3)); //[]

        System.out.println(i1.containsAll(i1.intersect(i2))); // true

        Iterator iter = Empty.EMPTY.iterator();
        try {
            iter.next();
        } catch (NoSuchElementException e) {
            System.out.println(e.getMessage()); // EMPTY has no elements!

        }

    }
}

// Ein 'Interval' ist eine aufsteigend iterierbare Menge
// von aufeinander folgenden ganzen Zahlen und stellt einfache
// Mengenoperationen zur Verfügung.
interface Interval extends Iterable {

    // liefert 'true' genau dann, wenn 'n' in der Menge enthalten ist
    boolean contains(Integer n);

    // liefert 'true' genau dann, wenn alle Zahlen aus 'iv' enthalten sind.
    boolean containsAll(Interval iv);

    // liefert ein Objekt von 'Interval', das der Schnittmenge mit 'iv' entspricht.
    Interval intersect(Interval iv);

    // liefert 'true' genau dann, wenn das Objekt die leere Menge repräsentiert.
    boolean isEmpty();

    // liefert 'true' genau dann, wenn die Menge genau die gleichen Zahlen
    // enthält wie 'o' (und 'o' auch ein 'Interval'-Objekt ist).
    boolean equals(Object o);

    // liefert den hashcode
    int hashCode();
}

// Iterierbare Objekte mit ganzzahligen Elementen
interface Iterable extends java.lang.Iterable<Integer> {
    Iterator iterator();
}

// Ein Iterator über ganze Zahlen.
interface Iterator extends java.util.Iterator<Integer> {
    boolean hasNext();

    Integer next();
}

// 'Empty' repräsentiert die leere Menge.
class Empty implements Interval {

    // Öffentliches Objekt zur Repräsentation der leeren Menge.
    public static final Empty EMPTY = new Empty();

    // Konstruktor (wird nur von 'Empty' genutzt)
    private Empty() {

    }

    public String toString(){
        return "";
    }

    @Override
    public boolean contains(Integer n) {
        return false;
    }

    @Override
    public boolean containsAll(Interval iv) {
        return false;
    }

    @Override
    public Interval intersect(Interval iv) {
        return null;
    }

    @Override
    public boolean isEmpty() {
        return false;
    }

    //TODO: Fehlende Teile der Klasse implementieren

}

// 'NonEmpty' repräsentiert eine aufsteigend iterierbare Menge von aufeinander folgenden ganzen Zahlen,
// die mindestens eine Zahl enthält. 'NonEmpty' wird durch Untergrenze 'lower' und Obergenze 'upper'
// des Intervalls bestimmt.
class NonEmpty implements Interval {

    public NonEmpty(Integer lower, Integer upper){

    }



    public String toString(){
        return "";
    }

    @Override
    public boolean contains(Integer n) {
        return false;
    }

    @Override
    public boolean containsAll(Interval iv) {
        return false;
    }

    @Override
    public Interval intersect(Interval iv) {
        return null;
    }

    @Override
    public boolean isEmpty() {
        return false;
    }
}
